'use strict';

module.exports = function(o) {
  var languages = o.languages || [];
  var style = o.style || noop;

  if(!languages.length) {
    console.warn('highlight-plugin - no `languages` to use for highlighting were set!');
  }

  return {
    bodyContent: function(options) {
      style();

      var React = require('react');

      return React.createClass({
        render: function () {
          return null;
        }
      });
    },
    postProcessItems: function(items) {
      var highlight = require('highlight.js').highlightAuto;
      var _ = require('lodash');
      var he = require('he');
      var cheerio = require('cheerio');

      _.each(items, function (item) {
        if(!item.content) {
          return;
        }

        var $ = cheerio.load(item.content);

        $('code').replaceWith(function(i, e) {
            var $e = $(e);
            var text = $e.text();

            if(text.split('\n').length < 2) {
              return $('<code>' + he.encode(text) + '</code>');
            }

            var val = he.decode(highlight($e.html(), languages).value);

            return $e.html(val);
        });

        item.content = $.html();
      });

      return items;
    }
  };
};

function noop() {}
